# This file was created automatically by SWIG.
import nonlinearc
from ooflib.SWIG.engine.properties import PropertyPtr
from ooflib.SWIG.engine.property.elasticity.cijkl import CijklPtr
from ooflib.SWIG.engine.property.elasticity.elasticity import ElasticityPtr
class NonLinearElasticityPropPtr(ElasticityPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def cijkl_pointer(self, *_args, **_kwargs):
        val = apply(nonlinearc.NonLinearElasticityProp_cijkl_pointer,(self,) + _args, _kwargs)
        if val: val = CijklPtr(val) 
        return val
    def __repr__(self):
        return "<C NonLinearElasticityProp instance at %s>" % (self.this,)
class NonLinearElasticityProp(NonLinearElasticityPropPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(nonlinearc.new_NonLinearElasticityProp,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: nonlinear.spy,v $
# $Revision: 1.6 $
# $Author: vrc $
# $Date: 2007-09-26 22:03:19 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

from ooflib.common.IO import parameter
from ooflib.SWIG.common import config
from ooflib.engine import problem
from ooflib.engine import propertyregistration
from ooflib.engine.IO import isocijkl
import types

PropertyRegistration = propertyregistration.PropertyRegistration
FloatParameter = parameter.FloatParameter


if config.devel()>=1:
    PropertyRegistration(
        'Mechanical:Elasticity:NonLinearElasticity', NonLinearElasticityProp,
        "ooflib.SWIG.engine.property.elasticity.nonlinear.nonlinear",200,
        [isocijkl.IsotropicCijklParameter('cijkl',
                     isocijkl.IsotropicRank4TensorEnu(young=1.0, poisson=0.2),
                                                tip=parameter.emptyTipString),
         FloatParameter('hardening', 0.0, tip = 'Reversible rate of change of the elastic constant upon applied strain.')],
        fields=[problem.Displacement],
        fluxes=[problem.Stress],
        outputs=["Energy"],
        propertyType="Elasticity",
        nonlinear=1)
